#! /usr/bin/python
# -*- coding: cp936 -*-

# #############################################################
# Copyright (c) 2007 elias.soong@gmail.com
# http://www.elias.cn/index.php?n=MyProject.PyEyouAgent

# ļʣEyouϵͳͨWebʽе½˳ѯȲĴ⣬
# ٷṩ߿ͻȣ򿪷Դ룬ûõضƣ
# PythonõĿƽ̨ԡ

# ˳õĳ򣬺ϲarithboy@gmail.comĸ´룬õ
# 0.1汾ʵӿͳķ룬ûԼҪ
# ޸ġ

# 2006-03-01, Version 0.1:
# ṹʵֿļͽ룻ԶȡSessionId⡣
# 2006-03-07, Version 0.2:
# checkAccount()ץȡIPִַļԡ
# 2006-05-23, Version 0.3:
# check()ӦeYouҳ޸ġ
# 2007-07-05, Version 0.4:
# domainmodeĴ
# ҪmodeЧ뽫֮ΪURLһַͣGETʧЧ

""" ʣEyouؿͻ˴ by elias.soong@gmail.com """

__version__ = "0.3"

import httplib,urllib,re,sys,time

class EyouAgent:
    "Eyou gateway connecting agent lib."
    RETURN_CODE = {"Success":0,"LoginFailed":104,"CheckFailed":105,"CheckIpFailed":106,"CheckReportFailed":107,"LogoutFailed":108,"ConnectFailed":109,"KickFailed":110,"LogoffFailed":111,"OnLine":201,"OffLine":202,"CheckError":204,"AccountNotUsing":208,"International":301,"National":302,"CityWide":303,"ModeError":304}
    
    # ʼ
    # ҪserverSettingһԪ飺IP½ַţ
    def __init__(self,userId,passwd,serverSetting,mode,logFile=None,debug=0):
        self.userId = userId
        self.passwd = passwd
        self.serverIp = serverSetting[0]
        self.loginParam = serverSetting[1]
        self.domainId = serverSetting[2]
	self.mode = mode
        self.session = None
        self.headers = {"Content-type": "application/x-www-form-urlencoded","Accept": "text/plain"}
        self.cookieHeaders = None
        if logFile == None:
            self.log = self.log2screen
        else:
            self.log = self.log2file
            self.logFile = logFile
        self.debug = debug
        self.log("Class inited!")
    
    # ־ϢӡĻ
    def log2screen(self,logBody):
        print "==="+time.ctime(time.time())+"==="
        print logBody
    
    # ־Ϣ¼ļ
    def log2file(self,logBody):
        sys.stdout = open(self.logFile,"at")
        print "==="+time.ctime(time.time())+"==="
        print logBody
        sys.stdout.close()
        sys.stdout = sys.__stdout__
    
    # ½ءԷ񡱹
    def login(self):
        params = urllib.urlencode({"logintype":self.loginParam,"loginuser":self.userId,"domainid":self.domainId,"password":self.passwd,"refer":"https://"+self.serverIp+"/"})
        try:
            conn = httplib.HTTPSConnection(self.serverIp)
            conn.request("POST", "/php/user_login.php", params, self.headers)
            response = conn.getresponse()
            self.session = re.search(r"(PHPSESSID=\w+);",response.getheader("Set-Cookie")).group(1)
            self.cookieHeaders = {"Cookie":self.session}
            self.cookieHeaders.update(self.headers)
            if self.debug>0 :
                self.log((response.status, response.reason, response.getheader("Set-Cookie")))
                self.log(self.session)
                self.log((self.cookieHeaders, self.headers))
                self.log(response.read())
            conn.close()
        except:
            if self.debug>0 :
                self.log((sys.exc_info()[0],sys.exc_info()[1],sys.exc_info()[2]))
            self.log("Login Failed")
            return self.RETURN_CODE["LoginFailed"]
        self.log("Login Success")
        return self.RETURN_CODE["Success"]
    
    # 
    # modeȡֵ0,1,2ֱʾ򡢹ڡʡ
    def connect(self,mode=None):
        if mode == None:
            params = urllib.urlencode({"mode":str(self.mode)})
	    mode = self.mode
        else:
            params = urllib.urlencode({"mode":str(mode)})
        try:
            conn = httplib.HTTPSConnection(self.serverIp)
	    # 䲻getmode=*᲻ãǹʵ½
	    # modeURLз;û
            # conn.request("GET", "/php/login_net.php?mode=0", params, self.cookieHeaders)
            conn.request("GET", "/php/login_net.php?mode="+mode, params, self.cookieHeaders)
            response = conn.getresponse()
            content = response.read()
            if self.debug>0 :
                self.log(self.cookieHeaders)
                self.log(content)
		self.log(params)
            conn.close()
        except:
            if self.debug>0 :
                self.log((sys.exc_info()[0],sys.exc_info()[1],sys.exc_info()[2]))
            self.log("Connect Failed")
            return self.RETURN_CODE["ConnectFailed"]
        self.log("Connect Success")
        return self.RETURN_CODE["Success"]
    
    # 
    def kick(self):
        params = urllib.urlencode({"ip":self.checkAccount(),"password":self.passwd})
        try:
            conn = httplib.HTTPSConnection(self.serverIp)
            conn.request("POST", "/php/kickself.php", params, self.cookieHeaders)
            response = conn.getresponse()
            content = response.read()
            if self.debug>0 :
                self.log(self.cookieHeaders)
                self.log(content)
            conn.close()
        except:
            if self.debug>0 :
                self.log((sys.exc_info()[0],sys.exc_info()[1],sys.exc_info()[2]))
            self.log("Kick Failed")
            return self.RETURN_CODE["KickFailed"]
        self.log("Kick Success")
        return self.RETURN_CODE["Success"]
    
    # עǰ
    def logout(self):
        params = urllib.urlencode({})
        try:
            conn = httplib.HTTPSConnection(self.serverIp)
            conn.request("GET", "/php/logout_net.php", params, self.cookieHeaders)
            response = conn.getresponse()
            content = response.read()
            if self.debug>0 :
                self.log(self.cookieHeaders)
                self.log(content)
            conn.close()
        except:
            if self.debug>0 :
                self.log((sys.exc_info()[0],sys.exc_info()[1],sys.exc_info()[2]))
            self.log("Logout Failed")
            return self.RETURN_CODE["LogoutFailed"]
        self.log("Logout Success")
        return self.RETURN_CODE["Success"]
    
    # עǰ½
    def logoff(self):
        params = urllib.urlencode({})
        try:
            conn = httplib.HTTPSConnection(self.serverIp)
            conn.request("GET", "/php/user_logoff.php", params, self.cookieHeaders)
            response = conn.getresponse()
            content = response.read()
            if self.debug>0 :
                self.log(self.cookieHeaders)
                self.log(content)
            conn.close()
        except:
            if self.debug>0 :
                self.log((sys.exc_info()[0],sys.exc_info()[1],sys.exc_info()[2]))
            self.log("Logoff Failed")
            return self.RETURN_CODE["LogoffFailed"]
        self.log("Logoff Success")
        return self.RETURN_CODE["Success"]
    
    # 鵱ǰ״̬
    # زʽ״̬ʺ½𣬵½ʱ䣬УУûУУ·ãУУ
    def check(self):
        params = urllib.urlencode({})
        try:
            conn = httplib.HTTPSConnection(self.serverIp)
            conn.request("GET", "/php/onlinestatus.php", params, self.cookieHeaders)
            response = conn.getresponse()
            content = response.read()
            if self.debug>0 :
                self.log(self.cookieHeaders)
                self.log(content)
            conn.close()
            result = list(range(12))
            if "Ѿڱ" in content:
                result[0] = self.RETURN_CODE["OnLine"]
            elif "ûдӱ¼" in content:
                return (self.RETURN_CODE["OffLine"])
            else:
                return (self.RETURN_CODE["CheckError"])
            result[1] = re.search(r'<div align="right"><b>û:</b></div>\s+</td>\s+<td bgcolor=#\w+ width=\w+>\s+<div align="\w+">(\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*)</div>',content).group(1)
            str = re.search(r'<div align="right"><b>߷ʽ:</b></div>\s+</td>\s+<td bgcolor=#\w+ width=\w+>\s+<div align="\w+">(\S+)</div>',content).group(1)
            if self.debug>0 :
                self.log("["+str+"]")
            if str == "":
                result[2] = self.RETURN_CODE["International"]
            elif str == "":
                result[2] = self.RETURN_CODE["National"]
            elif str == "":
                result[2] = self.RETURN_CODE["CityWide"]
            else:
                result[2] = self.RETURN_CODE["ModeError"]
##            result[3] = re.search(r'<b>ʱ:</b></div>\s+</td>\s+<td bgcolor=#\w+ height="\w+">\s+<div align="\w+">([\d\s\-:]+)</div>',content).group(1)
##            result[4] = re.search(r'<b>:</b></div>\s+</td>\s+<td align=\w+ bgcolor=#\w+ width=\w+>\s+<div align="\w+">([\d\.,]+)&nbsp;Mb<br>[\d\.,]+&nbsp;Mb</div>',content).group(1)
##            result[5] = re.search(r'<b>:</b></div>\s+</td>\s+<td align=\w+ bgcolor=#\w+ width=\w+>\s+<div align="\w+">[\d\.,]+&nbsp;Mb<br>([\d\.,]+)&nbsp;Mb</div>',content).group(1)
##            result[6] = re.search(r'<b>û:</b></div>\s+</td>\s+</td>\s+<td bgcolor=#\w+ width=\w+>\s+<div align="\w+">([\d\.,]+) Ԫ</div>',content).group(1)
##            result[7] = re.search(r'<b>:</b></div>\s+</td>\s+<td align=\w+ bgcolor=#\w+ width=\w+>\s+<div align="\w+">([\d\.,]+)&nbsp;Mb<br>[\d\.,]+&nbsp;Mb</div>',content).group(1)
##            result[8] = re.search(r'<b>:</b></div>\s+</td>\s+<td align=\w+ bgcolor=#\w+ width=\w+>\s+<div align="\w+">[\d\.,]+&nbsp;Mb<br>([\d\.,]+)&nbsp;Mb</div>',content).group(1)
##            result[9] = re.search(r'<b>·:</b></div>\s+</td>\s+<td bgcolor=#\w+ width=\w+>\s+<div align="\w+">([\d\.,]+) Ԫ</div>',content).group(1)
##            result[10] = re.search(r'<b>:</b></div>\s+</td>\s+<td align=\w+ bgcolor=#\w+ width=\w+>\s+<div align="\w+">([\d\.,]+)&nbsp;Mb<br>[\d\.,]+&nbsp;Mb</div>',content).group(1)
##            result[11] = re.search(r'<b>:</b></div>\s+</td>\s+<td align=\w+ bgcolor=#\w+ width=\w+>\s+<div align="\w+">[\d\.,]+&nbsp;Mb<br>([\d\.,]+)&nbsp;Mb</div>',content).group(1)
            if self.debug>0 :
                self.log(result)
            self.log("Check Success")
            return result
        except:
            if self.debug>0 :
                self.log((sys.exc_info()[0],sys.exc_info()[1],sys.exc_info()[2]))
            self.log("Check Failed")
            return (self.RETURN_CODE["CheckFailed"])
    
    # 鵱ǰʺ״̬رĿǰʹôʺߵIPַ
    def checkAccount(self):
        params = urllib.urlencode({})
        try:
            conn = httplib.HTTPSConnection(self.serverIp)
            conn.request("GET", "/php/useronlinelist.php", params, self.cookieHeaders)
            response = conn.getresponse()
            content = response.read()
            if self.debug>0 :
                self.log(self.cookieHeaders)
                self.log(content)
            conn.close()
            no = int(re.search(r"(\d+)¼",content).group(1))
            if self.debug>0 :
                self.log(no)
            if no == 0 :
                self.log("Check Ip Success")
                return self.RETURN_CODE["AccountNotUsing"]
            else:
                ip = re.search(r"\d+\.\d+\.\d+\.\d+",content).group(0)
                self.log("Check Ip Success")
                return ip
        except:
            if self.debug>0 :
                self.log((sys.exc_info()[0],sys.exc_info()[1],sys.exc_info()[2]))
            self.log("Check Ip Failed")
            return self.RETURN_CODE["CheckIpFailed"]
    
    # ѯ
    # ݸʽʱ䣬УУУУУУʹý
    def query(self):
        params = urllib.urlencode({"thismonth":"1"})
        try:
            conn = httplib.HTTPSConnection(self.serverIp)
            conn.request("POST", "/php/user_report.php", params, self.cookieHeaders)
            response = conn.getresponse()
            content = response.read()
            if self.debug>0 :
                self.log(self.cookieHeaders)
                self.log(content)
            conn.close()
            result = list(range(8))
            m = re.search(r'<td width="\w+%" heigth="\w+" align=\w+ height="\w+">\s+<div align="center">([\d:]+)</div>\s+</td>\s+<td width="\w+%" heigth="\w+" align=\w+ nowrap height="\w+">\s+<div align="\w+">([\d\.,]+)</div>\s+</td>\s+<td width="\w+%" heigth="\w+" align=\w+ nowrap height="\w+">\s+<div align="\w+">([\d\.,]+)</div>\s+</td>\s+<td width="\w+%" heigth="\w+" align=\w+ nowrap height="\w+">\s+<div align="\w+">([\d\.,]+)</div>\s+</td>\s+<td width="\w+%" heigth="\w+" align=\w+ nowrap height="\w+">\s+<div align="\w+">([\d\.,]+)</div>\s+</td>\s+<td width="\w+%" heigth="\w+" align=\w+ nowrap height="\w+">\s+<div align="\w+">([\d\.,]+)</div>\s+</td>\s+<td width="\w+%" heigth="\w+" align=\w+ nowrap height="\w+">\s+<div align="\w+">([\d\.,]+)</div>\s+</td>\s+<td width="\w+%" heigth="\w+" align=\w+ nowrap height="\w+">\s+<div align="\w+">([\d\.,]+)</div>\s+</td>',content)
            self.log("Check Report Success")
            return m.groups()
        except:
            if self.debug>0 :
                self.log((sys.exc_info()[0],sys.exc_info()[1],sys.exc_info()[2]))
            self.log("Check Report Failed")
            return (self.RETURN_CODE["CheckReportFailed"])

class CheckNet:
    "Check if the machine is on the internet."
    RETURN_CODE = {"OffLine":1,"OnLine":0}
    
    def __init__(self,url,text,logFile=None):
        self.url = url
        self.text = text
        if logFile == None:
            self.log = self.log2screen
        else:
            self.log = self.log2file
            self.logFile = logFile
    
    # ־ϢӡĻ
    def log2screen(self,logBody):
        print "==="+time.ctime(time.time())+"==="
        print logBody
    
    # ־Ϣ¼ļ
    def log2file(self,logBody):
        sys.stdout = open(self.logFile,"at")
        print "==="+time.ctime(time.time())+"==="
        print logBody
        sys.stdout.close()
        sys.stdout = sys.__stdout__
    
    def check(self):
        search=-1
        try:
            page=urllib.urlopen(self.url)
            search=page.read().find(self.text)
        except:
            search=-1
        if (search==-1):
            self.log("Unlogin!")
            return self.RETURN_CODE["OffLine"]
        else:
            self.log("Logged on!")
            return self.RETURN_CODE["OnLine"]

if __name__=="__main__":
    # ô
    account = "MyAccount"
    password = "MyPassword"
    server = ("210.77.16.29","Է","2")
    ea = EyouAgent(account,password,server,debug=1) #"logfile.txt",1)
    print ea.login()
    print ea.check()
    print ea.checkAccount()
    print ea.query()
    print ea.logout()
    print ea.check()
    print ea.connect(2)
    print ea.check()
##    print ea.kick()
##    print ea.check()
##    print ea.connect()
##    print ea.check()
##    print ea.logoff()
    pass
    cn = CheckNet("http://www.163.com","163.com")
    print cn.check()
    pass
    